Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeTreeModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeTreeModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeTreeModel.cs	(revision 16892)
@@ -0,0 +1,132 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("FAF1F955-82F3-4824-9759-9D2846E831AE")]
+  public class RegressionNodeTreeModel : RegressionModel, IM5Model {
+    public const string NumCurrentLeafsResultName = "Number of current leafs";
+    public const string RootVariableName = "Root";
+    #region Properties
+    [Storable]
+    internal RegressionNodeModel Root { get; private set; }
+    #endregion
+
+    #region HLConstructors & Cloning
+    [StorableConstructor]
+    protected RegressionNodeTreeModel(StorableConstructorFlag _) : base(_) { }
+    protected RegressionNodeTreeModel(RegressionNodeTreeModel original, Cloner cloner) : base(original, cloner) {
+      Root = cloner.Clone(original.Root);
+    }
+    protected RegressionNodeTreeModel(string targetVariable) : base(targetVariable) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RegressionNodeTreeModel(this, cloner);
+    }
+    #endregion
+
+    internal static RegressionNodeTreeModel CreateTreeModel(string targetAttr, RegressionTreeParameters regressionTreeParams) {
+      return regressionTreeParams.LeafModel.ProvidesConfidence ? new ConfidenceRegressionNodeTreeModel(targetAttr) : new RegressionNodeTreeModel(targetAttr);
+    }
+
+    #region RegressionModel
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get { return Root.VariablesUsedForPrediction ?? new List<string>(); }
+    }
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      if (Root == null) throw new NotSupportedException("The model has not been built yet");
+      return Root.GetEstimatedValues(dataset, rows);
+    }
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+    #endregion
+
+    #region IM5Model
+    public void Build(IReadOnlyList<int> trainingRows, IReadOnlyList<int> pruningRows, IScope statescope, ResultCollection results, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)statescope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      //start with one node
+      if (Root == null)
+        Root = RegressionNodeModel.CreateNode(regressionTreeParams.TargetVariable, regressionTreeParams);
+
+      //split into (overfitted tree)
+      regressionTreeParams.Splitter.Split(this, trainingRows, statescope, cancellationToken);
+
+      //prune
+      regressionTreeParams.Pruning.Prune(this, trainingRows, pruningRows, statescope, cancellationToken);
+
+      //build final leaf models
+      regressionTreeParams.LeafModel.Build(this, trainingRows.Union(pruningRows).ToArray(), statescope, cancellationToken);
+    }
+
+    public void Update(IReadOnlyList<int> rows, IScope statescope, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)statescope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      regressionTreeParams.LeafModel.Build(this, rows, statescope, cancellationToken);
+    }
+
+    public static void Initialize(IScope stateScope) {
+      var param = (RegressionTreeParameters)stateScope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      stateScope.Variables.Add(new Variable(RootVariableName, RegressionNodeModel.CreateNode(param.TargetVariable, param)));
+    }
+    #endregion
+
+    public void BuildModel(IReadOnlyList<int> trainingRows, IReadOnlyList<int> pruningRows, IScope statescope, ResultCollection results, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)statescope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      //start with one node
+      Root = RegressionNodeModel.CreateNode(regressionTreeParams.TargetVariable, regressionTreeParams);
+
+      //split into (overfitted tree)
+      regressionTreeParams.Splitter.Split(this, trainingRows, statescope, cancellationToken);
+
+      //prune
+      regressionTreeParams.Pruning.Prune(this, trainingRows, pruningRows, statescope, cancellationToken);
+    }
+
+    [StorableType("E84ACC40-5694-4E40-A947-190673643206")]
+    private sealed class ConfidenceRegressionNodeTreeModel : RegressionNodeTreeModel, IConfidenceRegressionModel {
+      #region HLConstructors & Cloning
+      [StorableConstructor]
+      private ConfidenceRegressionNodeTreeModel(StorableConstructorFlag _) : base(_) { }
+      private ConfidenceRegressionNodeTreeModel(ConfidenceRegressionNodeTreeModel original, Cloner cloner) : base(original, cloner) { }
+      public ConfidenceRegressionNodeTreeModel(string targetVariable) : base(targetVariable) { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new ConfidenceRegressionNodeTreeModel(this, cloner);
+      }
+      #endregion
+
+      public IEnumerable<double> GetEstimatedVariances(IDataset dataset, IEnumerable<int> rows) {
+        if (Root == null) throw new NotSupportedException("The model has not been built yet");
+        return ((IConfidenceRegressionModel)Root).GetEstimatedVariances(dataset, rows);
+      }
+      public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+        return new ConfidenceRegressionSolution(this, problemData);
+      }
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleModel.cs	(revision 16892)
@@ -0,0 +1,179 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("425AF262-A756-4E9A-B76F-4D2480BEA4FD")]
+  public class RegressionRuleModel : RegressionModel, IM5Model {
+    #region Properties
+    [Storable]
+    public string[] SplitAttributes { get; set; }
+    [Storable]
+    private double[] SplitValues { get; set; }
+    [Storable]
+    private Comparison[] Comparisons { get; set; }
+    [Storable]
+    private IRegressionModel RuleModel { get; set; }
+    [Storable]
+    private IReadOnlyList<string> variables;
+    #endregion
+
+    #region HLConstructors
+    [StorableConstructor]
+    protected RegressionRuleModel(StorableConstructorFlag _) : base(_) { }
+    protected RegressionRuleModel(RegressionRuleModel original, Cloner cloner) : base(original, cloner) {
+      if (original.SplitAttributes != null) SplitAttributes = original.SplitAttributes.ToArray();
+      if (original.SplitValues != null) SplitValues = original.SplitValues.ToArray();
+      if (original.Comparisons != null) Comparisons = original.Comparisons.ToArray();
+      RuleModel = cloner.Clone(original.RuleModel);
+      if (original.variables != null) variables = original.variables.ToList();
+    }
+    private RegressionRuleModel(string target) : base(target) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RegressionRuleModel(this, cloner);
+    }
+    #endregion
+
+    internal static RegressionRuleModel CreateRuleModel(string target, RegressionTreeParameters regressionTreeParams) {
+      return regressionTreeParams.LeafModel.ProvidesConfidence ? new ConfidenceRegressionRuleModel(target) : new RegressionRuleModel(target);
+    }
+
+    #region IRegressionModel
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get { return variables; }
+    }
+
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      if (RuleModel == null) throw new NotSupportedException("The model has not been built correctly");
+      return RuleModel.GetEstimatedValues(dataset, rows);
+    }
+
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+    #endregion
+
+    public void Build(IReadOnlyList<int> trainingRows, IReadOnlyList<int> pruningRows, IScope statescope, ResultCollection results, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)statescope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      variables = regressionTreeParams.AllowedInputVariables.ToList();
+
+      //build tree and select node with maximum coverage
+      var tree = RegressionNodeTreeModel.CreateTreeModel(regressionTreeParams.TargetVariable, regressionTreeParams);
+      tree.BuildModel(trainingRows, pruningRows, statescope, results, cancellationToken);
+      var nodeModel = tree.Root.EnumerateNodes().Where(x => x.IsLeaf).MaxItems(x => x.NumSamples).First();
+
+      var satts = new List<string>();
+      var svals = new List<double>();
+      var reops = new List<Comparison>();
+
+      //extract splits
+      for (var temp = nodeModel; temp.Parent != null; temp = temp.Parent) {
+        satts.Add(temp.Parent.SplitAttribute);
+        svals.Add(temp.Parent.SplitValue);
+        reops.Add(temp.Parent.Left == temp ? Comparison.LessEqual : Comparison.Greater);
+      }
+      Comparisons = reops.ToArray();
+      SplitAttributes = satts.ToArray();
+      SplitValues = svals.ToArray();
+      int np;
+      RuleModel = regressionTreeParams.LeafModel.BuildModel(trainingRows.Union(pruningRows).Where(r => Covers(regressionTreeParams.Data, r)).ToArray(), regressionTreeParams, cancellationToken, out np);
+    }
+
+    public void Update(IReadOnlyList<int> rows, IScope statescope, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)statescope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      int np;
+      RuleModel = regressionTreeParams.LeafModel.BuildModel(rows, regressionTreeParams, cancellationToken, out np);
+    }
+
+    public bool Covers(IDataset dataset, int row) {
+      return !SplitAttributes.Where((t, i) => !Comparisons[i].Compare(dataset.GetDoubleValue(t, row), SplitValues[i])).Any();
+    }
+
+    public string ToCompactString() {
+      var mins = new Dictionary<string, double>();
+      var maxs = new Dictionary<string, double>();
+      for (var i = 0; i < SplitAttributes.Length; i++) {
+        var n = SplitAttributes[i];
+        var v = SplitValues[i];
+        if (!mins.ContainsKey(n)) mins.Add(n, double.NegativeInfinity);
+        if (!maxs.ContainsKey(n)) maxs.Add(n, double.PositiveInfinity);
+        if (Comparisons[i] == Comparison.LessEqual) maxs[n] = Math.Min(maxs[n], v);
+        else mins[n] = Math.Max(mins[n], v);
+      }
+      if (maxs.Count == 0) return "";
+      var s = new StringBuilder();
+      foreach (var key in maxs.Keys)
+        s.Append(string.Format("{0} ∈ [{1:e2}; {2:e2}] && ", key, mins[key], maxs[key]));
+      s.Remove(s.Length - 4, 4);
+      return s.ToString();
+    }
+
+    [StorableType("7302AA30-9F58-42F3-BF6A-ECF1536508AB")]
+    private sealed class ConfidenceRegressionRuleModel : RegressionRuleModel, IConfidenceRegressionModel {
+      #region HLConstructors
+      [StorableConstructor]
+      private ConfidenceRegressionRuleModel(StorableConstructorFlag _) : base(_) { }
+      private ConfidenceRegressionRuleModel(ConfidenceRegressionRuleModel original, Cloner cloner) : base(original, cloner) { }
+      public ConfidenceRegressionRuleModel(string targetAttr) : base(targetAttr) { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new ConfidenceRegressionRuleModel(this, cloner);
+      }
+      #endregion
+
+      public IEnumerable<double> GetEstimatedVariances(IDataset dataset, IEnumerable<int> rows) {
+        return ((IConfidenceRegressionModel)RuleModel).GetEstimatedVariances(dataset, rows);
+      }
+
+      public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+        return new ConfidenceRegressionSolution(this, problemData);
+      }
+    }
+  }
+
+  [StorableType("152DECE4-2692-4D53-B290-974806ADCD72")]
+  internal enum Comparison {
+    LessEqual,
+    Greater
+  }
+
+  internal static class ComparisonExtentions {
+    public static bool Compare(this Comparison op, double x, double y) {
+      switch (op) {
+        case Comparison.Greater:
+          return x > y;
+        case Comparison.LessEqual:
+          return x <= y;
+        default:
+          throw new ArgumentOutOfRangeException(op.ToString(), op, null);
+      }
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleSetModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleSetModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionRuleSetModel.cs	(revision 16892)
@@ -0,0 +1,186 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("7B4D9AE9-0456-4029-80A6-CCB5E33CE356")]
+  public class RegressionRuleSetModel : RegressionModel, IM5Model {
+    private const string NumRulesResultName = "Number of rules";
+    private const string CoveredInstancesResultName = "Covered instances";
+    public const string RuleSetStateVariableName = "RuleSetState";
+
+    #region Properties
+    [Storable]
+    internal List<RegressionRuleModel> Rules { get; private set; }
+    #endregion
+
+    #region HLConstructors & Cloning
+    [StorableConstructor]
+    protected RegressionRuleSetModel(StorableConstructorFlag _) : base(_) { }
+    protected RegressionRuleSetModel(RegressionRuleSetModel original, Cloner cloner) : base(original, cloner) {
+      if (original.Rules != null) Rules = original.Rules.Select(cloner.Clone).ToList();
+    }
+    protected RegressionRuleSetModel(string targetVariable) : base(targetVariable) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RegressionRuleSetModel(this, cloner);
+    }
+    #endregion
+
+    internal static RegressionRuleSetModel CreateRuleModel(string targetAttr, RegressionTreeParameters regressionTreeParams) {
+      return regressionTreeParams.LeafModel.ProvidesConfidence ? new ConfidenceRegressionRuleSetModel(targetAttr) : new RegressionRuleSetModel(targetAttr);
+    }
+
+    #region RegressionModel
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get {
+        var f = Rules.FirstOrDefault();
+        return f != null ? (f.VariablesUsedForPrediction ?? new List<string>()) : new List<string>();
+      }
+    }
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      if (Rules == null) throw new NotSupportedException("The model has not been built yet");
+      return rows.Select(row => GetEstimatedValue(dataset, row));
+    }
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+    #endregion
+
+    #region IM5Model
+    public void Build(IReadOnlyList<int> trainingRows, IReadOnlyList<int> pruningRows, IScope stateScope, ResultCollection results, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)stateScope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      var ruleSetState = (RuleSetState)stateScope.Variables[RuleSetStateVariableName].Value;
+
+      if (ruleSetState.Code <= 0) {
+        ruleSetState.Rules.Clear();
+        ruleSetState.TrainingRows = trainingRows;
+        ruleSetState.PruningRows = pruningRows;
+        ruleSetState.Code = 1;
+      }
+
+      do {
+        var tempRule = RegressionRuleModel.CreateRuleModel(regressionTreeParams.TargetVariable, regressionTreeParams);
+        cancellationToken.ThrowIfCancellationRequested();
+
+        if (!results.ContainsKey(NumRulesResultName)) results.Add(new Result(NumRulesResultName, new IntValue(0)));
+        if (!results.ContainsKey(CoveredInstancesResultName)) results.Add(new Result(CoveredInstancesResultName, new IntValue(0)));
+
+        var t1 = ruleSetState.TrainingRows.Count;
+        tempRule.Build(ruleSetState.TrainingRows, ruleSetState.PruningRows, stateScope, results, cancellationToken);
+        ruleSetState.TrainingRows = ruleSetState.TrainingRows.Where(i => !tempRule.Covers(regressionTreeParams.Data, i)).ToArray();
+        ruleSetState.PruningRows = ruleSetState.PruningRows.Where(i => !tempRule.Covers(regressionTreeParams.Data, i)).ToArray();
+        ruleSetState.Rules.Add(tempRule);
+        ((IntValue)results[NumRulesResultName].Value).Value++;
+        ((IntValue)results[CoveredInstancesResultName].Value).Value += t1 - ruleSetState.TrainingRows.Count;
+      }
+      while (ruleSetState.TrainingRows.Count > 0);
+      Rules = ruleSetState.Rules;
+    }
+    public void Update(IReadOnlyList<int> rows, IScope stateScope, CancellationToken cancellationToken) {
+      foreach (var rule in Rules) rule.Update(rows, stateScope, cancellationToken);
+    }
+    public static void Initialize(IScope stateScope) {
+      stateScope.Variables.Add(new Variable(RuleSetStateVariableName, new RuleSetState()));
+    }
+    #endregion
+
+    #region Helpers
+    private double GetEstimatedValue(IDataset dataset, int row) {
+      foreach (var rule in Rules) {
+        if (rule.Covers(dataset, row))
+          return rule.GetEstimatedValues(dataset, row.ToEnumerable()).Single();
+      }
+      throw new ArgumentException("Instance is not covered by any rule");
+    }
+    #endregion
+
+    [StorableType("E114F3C9-3C1F-443D-8270-0E10CE12F2A0")]
+    public class RuleSetState : Item {
+      [Storable]
+      public List<RegressionRuleModel> Rules = new List<RegressionRuleModel>();
+      [Storable]
+      public IReadOnlyList<int> TrainingRows = new List<int>();
+      [Storable]
+      public IReadOnlyList<int> PruningRows = new List<int>();
+
+      //State.Code values denote the current action (for pausing)
+      //0...nothing has been done;
+      //1...splitting nodes;
+      [Storable]
+      public int Code = 0;
+
+      #region HLConstructors & Cloning
+      [StorableConstructor]
+      protected RuleSetState(StorableConstructorFlag _) : base(_) { }
+      protected RuleSetState(RuleSetState original, Cloner cloner) : base(original, cloner) {
+        Rules = original.Rules.Select(cloner.Clone).ToList();
+        TrainingRows = original.TrainingRows.ToList();
+        PruningRows = original.PruningRows.ToList();
+
+        Code = original.Code;
+      }
+      public RuleSetState() { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new RuleSetState(this, cloner);
+      }
+      #endregion
+    }
+
+    [StorableType("52E7992B-94CC-4960-AA82-1A399BE735C6")]
+    private sealed class ConfidenceRegressionRuleSetModel : RegressionRuleSetModel, IConfidenceRegressionModel {
+      #region HLConstructors & Cloning
+      [StorableConstructor]
+      private ConfidenceRegressionRuleSetModel(StorableConstructorFlag _) : base(_) { }
+      private ConfidenceRegressionRuleSetModel(ConfidenceRegressionRuleSetModel original, Cloner cloner) : base(original, cloner) { }
+      public ConfidenceRegressionRuleSetModel(string targetVariable) : base(targetVariable) { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new ConfidenceRegressionRuleSetModel(this, cloner);
+      }
+      #endregion
+
+      #region IConfidenceRegressionModel
+      public IEnumerable<double> GetEstimatedVariances(IDataset dataset, IEnumerable<int> rows) {
+        if (Rules == null) throw new NotSupportedException("The model has not been built yet");
+        return rows.Select(row => GetEstimatedVariance(dataset, row));
+      }
+      public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+        return new ConfidenceRegressionSolution(this, problemData);
+      }
+      private double GetEstimatedVariance(IDataset dataset, int row) {
+        foreach (var rule in Rules) {
+          if (rule.Covers(dataset, row)) return ((IConfidenceRegressionModel)rule).GetEstimatedVariances(dataset, row.ToEnumerable()).Single();
+        }
+        throw new ArgumentException("Instance is not covered by any rule");
+      }
+      #endregion
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Plugin.cs.frame
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Plugin.cs.frame	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Plugin.cs.frame	(revision 16892)
@@ -0,0 +1,48 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Algorithms.DataAnalysis plugin.
+  /// </summary>
+  [Plugin("HeuristicLab.Algorithms.DataAnalysis.M5", "Provides the M5' regression algorithm", "3.4.0.$WCREV$")]
+  [PluginFile("HeuristicLab.Algorithms.DataAnalysis.M5-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.ALGLIB", "3.7")]
+  [PluginDependency("HeuristicLab.Attic", "1.0")]
+  [PluginDependency("HeuristicLab.Algorithms.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Algorithms.DataAnalysis.Glmnet", "3.4")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.4")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+
+  public class Plugin : PluginBase {   
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Properties/AssemblyInfo.cs.frame	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Properties/AssemblyInfo.cs.frame	(revision 16892)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Algorithms.DataAnalysis.M5")]
+[assembly: AssemblyDescription("Provides the M5' regression algorithm")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2019 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.4.0")]
+[assembly: AssemblyFileVersion("3.4.0.$WCREV$")]
